{AddressBookPro.pas             }
{Author: Diana Herwono          }
{School: Shanghai High School   }
{IB Student Number: 0861 016    }
{Written in Borland Pascal v7.0 }
{Date: April 2002               }
{Purpose: Access Data File      }


program AddressBookPro;

const
  max=50;

type

  TAddressRec = record      {assigns fields for a contact record}
    firstname: string[20];
    lastname: string[20];
    address: string[50];
    phone: string[12];
    email: string[25]
  end;

  TEntryFile = file of TAddressRec;  {creates file of contact records}

  TAddressArr = array[1..max] of TAddressRec; {array of contact records}

var
  dataFile: TEntryFile;        {file of contact records}
  AddressBook: TAddressArr;    {array of contact records}
  Filename, response: string;  {external name of file, user's option}
  choice: char;                {user's option}
  Error, quitSub, Exit: boolean; {check for input errors, quit program}
  len, pos, tmpPos: integer;   {no. of records in file, 
				position of the record}

{*********************************************************************}

procedure ShowMainMenu (var choice:char);   {main menu}

begin
  writeln;
  writeln ('Welcome to AddressBookPro');
  writeln;
  writeln ('Please choose an option: ');
  writeln;
  writeln ('1.   Open an existing folder'); {user selects an option}
  writeln ('2.   Create a new folder');
  writeln ('3.   Delete an existing folder');
  writeln ('4.   Quit');
  writeln;
  writeln ('Input your choice (1-4): ');
  readln (choice);                          {read user's option}
end;                                        {end main menu}

{*********************************************************************}

procedure InvalidChoice (var choice: char; var Error: boolean);  
						
begin					{data trap}
  Error:=false;
  writeln ('Your selection was not valid.');
end;

{*********************************************************************}

function OpenFile (var Filename: string; var len: integer):boolean;

var
  tmpRec: TAddressRec;
  i: integer;

begin                                {open an existing file}
  i:=1;
  assign (dataFile, Filename);
  {$I-}
  reset(dataFile);                   {file is opened}
  {$I+}
  if IOResult = 0 then               {if file exists}
    begin
      while not EOF (dataFile) do
        begin
          read (dataFile, tmpRec);   {read data from file}
          AddressBook[i]:=tmpRec;    {read data into array}
          i:=i+1;                      
        end;
        len:=i-1;
        OpenFile:= true;
    end
  else
    OpenFile:= false;
end;

{*********************************************************************}

function CreateFile (var Filename: string):boolean;

var
  response: string;
  myResult: integer;

begin                             {Creates File}
  writeln;
  writeln ('Enter Filename:');    {user enters filename}
  readln (Filename);
  {$I-}
  assign (dataFile, Filename);    {file is created}
  reset(dataFile);
  {$I+}
  myResult := IOResult;
  If myResult =  0 then           {if file already exists}
    begin
      writeln ('This file exists. Do you wish to overwrite it? Y/N');
      readln (response);
      if ((response = 'y') or (response ='Y')) and (myResult = 0)  then
      begin
        {$I-}
        rewrite(dataFile);
        {$I+}
        if IOResult = 0 then
          begin
            CreateFile:= true;            {overwrite file}
            writeln ('Folder created.');
          end
        {else
          CreateFile:= false;
          writeln ('Folder not created.')}
        end
      end
      else
        begin
          {$I-}
           rewrite(dataFile);
           {$I+}
           if IOResult = 0 then
             begin
               CreateFile:= true;
               writeln ('Folder created.');
             end
           else
             CreateFile:= false;
        end;
end;

{*********************************************************************}

function DeleteFile (var Filename: string): boolean;

begin                                {delete file}
  assign (dataFile, Filename);
  erase (dataFile);                  {file is deleted}
  writeln ('Folder is deleted.');
end;

{*********************************************************************}

procedure Quit (var Exit: boolean);    {quit program}

begin
  Exit:= true;
  writeln;
  writeln ('Thankyou for using AddressBookPro!');
end;

{****************************************************************************}

procedure ShowOptionsMenu (var choice: char; len: integer); 
					
begin                                          {options menu}
  writeln;
  writeln ('Welcome to the Options Menu');
  writeln;
  if len=1 then
    writeln ('Folder contains 1 record.')      {display folder size}
  else
    writeln ('Folder contains ', len, ' records.'); 
  writeln;
  writeln ('Please choose an option:');
  writeln;
  writeln ('1. Display current record');       {user enters an option}
  writeln ('2. Add new record');
  writeln ('3. Delete current record');
  writeln ('4. Search for record');
  writeln ('5. Go to next record');
  writeln ('6. Go to previous record');
  writeln ('7. Go to first record');
  writeln ('8. Go to last record');
  writeln ('9. Close folder and save changes');
  writeln;
  writeln ('Input your choice (1-9):');
  readln (choice);                             {read user's option}
end;                                           {end options menu}

{*********************************************************************}

procedure DisplayRec (pos, len:integer);    {display record}

var
  tmpRec: TAddressRec;

begin
  if len=0 then                   {if file is empty}
    writeln ('Folder is empty.')  {do not show any record}
  else				  {if file is not empty}
    begin			  {show record}
      tmpRec := AddressBook[pos];
      writeln;
      writeln ('Record: ',pos);
      writeln;
      with tmpRec do
        begin
          writeln ('First Name:  ', firstname);   {write the headings}
          writeln ('Last Name:   ', lastname);
          writeln ('Address:     ', address);
          writeln ('Phone Number:', phone);
          writeln ('Email:       ', email);
        end;
    end;
end;

{*********************************************************************}

procedure AddNewRec (var len: integer);     {add new record}

var
  tmpRec: TAddressRec;
  i,j: integer;
  found: boolean;

begin
  writeln;
  with tmpRec do
    begin
      writeln ('Enter First Name:');{input data}
      readln (tmpRec.firstname);
      writeln ('Enter Last Name:');
      readln (tmpRec.lastname);
      writeln ('Enter Address:');
      readln (tmpRec.address);
      writeln ('Enter Phone Number:');
      readln (tmpRec.phone);
      writeln ('Enter Email:');
      readln (tmpRec.email);
    end;
  i:= 1;                            {find position}
  found:= false;
  while  (i <= len) and not found do
    begin
      if tmpRec.Firstname< addressbook[i].firstname then
        found:= true
      else
      i:= i+ 1;
    end;
  for j:= len downto i do           {following records shift to right}
    begin
      addressbook[j+1]:=addressbook[j];
     end;
  len:= len + 1;                    {no. of records increase by one}
  addressbook[i]:= tmpRec;
  pos:=i;			    {position at new record}
  writeln;
  writeln ('New record is saved.');
end;

{*********************************************************************}

procedure DeleteRec (var pos: integer);     {erase record}

var
  response: char;
  check: boolean;
  i:integer;
  tmpRec: TAddressRec;

begin
  if len=0 then                             {if file is empty}
    writeln ('Folder is empty.')            {do not continue}
  else
    begin
      writeln ('Delete record: ', pos , '   Y/N?');  {erase record?}
      readln (response);
      check:=false;
      if (response = 'y') or (response = 'Y') or (response = 'n') or (response = 'N') then
        check:=true
      else
        InvalidChoice(choice, error);       {if selection not yes or no}
      if (response = 'y') or (response = 'Y') then  {if selection is yes}
        begin
          for i:=pos to (len-1) do          {record deleted}
            begin
              AddressBook[i]:=AddressBook[i+1];
            end;
          len:=len-1;                 {no. of records decreases by one}
          writeln;
          writeln ('Record: ', pos ,' deleted.');
        end
      else
        writeln ('Record: ', pos ,' not deleted.'); {if selection is no}
      end;
end;

(****************************************************************************)

procedure SearchFile (var choice: char; len: integer); 

begin                                         {search for record}
  if len=0 then                               {if file is empty}
    writeln ('Folder is empty.')              {do not show search menu}
  else
    begin
      writeln;
      writeln ('Would you like to search by:');   {search menu}
      writeln ('1.   First Name');                {user enters option}
      writeln ('2.   Last Name');
      writeln;
      writeln ('Input your choice (1-2):');
      readln (choice);                            {read user's option}
    end;
end;

{*********************************************************************}

function SearchFirstName (var pos: integer):Boolean;

var
  i: integer;
  found,quit: boolean;
  searchname, response: string;

begin                                       {search by first name}
  writeln ('Please enter search keyword:'); {enter search word}
  readln (searchname);
  quit:= false;
  i:= 1;
  while (i<=len) and not quit do
    begin
      if AddressBook[i].firstname=searchname then  {if matches search word}
        begin
          DisplayRec(i, len);
          writeln ('Continue searching? Y/N');     {keep searching?}
          readln (response);
          if (response='n') or (response='N') then {if user enters no}
            begin
              pos:=i;
              quit:=true;                         {program stops searching}
            end
          else
            begin
              if (response='y') or (response='Y') then {if user enters yes}
                i:=i+1                        {program continues to search}
              else
                InvalidChoice(choice, error); {if user enters incorrect choice}
            end;
          end
      else
      i:=i+1;
    end;
{    writeln ('No record found.');}
end;

{****************************************************************************}

function SearchLastName (var pos: integer):Boolean;  {search by last name}

var
  i: integer;
  quit: boolean;
  searchname, response: string;

begin
  writeln ('Please enter Search keyword:');   {user enters search keyword}
  readln (searchname);
  quit:= false;
  i:= 1;
  while (i<=len) and not quit do
    begin
      if AddressBook[i].lastname=searchname then {if record matches search keyword}
        begin
          DisplayRec(i, len);
          writeln ('Continue searching? Y/N');  {ask for permission to continue searching}
          readln (response);
          if (response='n') or (response='N') then  {if response is no}
            begin
              pos:=i;
              quit:=true;            {program stops searching}
            end
          else
            begin
              if (response='y') or (response='Y') then  {if response is yes}
                i:=i+1                  {program continues searching}
              else
                InvalidChoice(choice, error); {if user enters an incorrect choice}
            end;
          end
      else
      i:=i+1;
    end;
   { writeln ('No record found.'); }
end;

{**************************************************************************}

procedure GoNextRec (var pos, len: integer);  {display next record}

var
  tmpRec: TAddressRec;

begin
  if len=0 then                         {if file is empty}
    writeln ('Folder is empty.')        {do not display any record}
  else
    begin
      pos:=pos+1;
      if pos>len then      {if current record is the last record in the file}
        pos:=len;          {program does not show next record}
      writeln;
      writeln ('Record: ',pos);
      tmpRec := AddressBook[pos];
      with tmpRec do
        DisplayRec(pos, len);  {display next record}
    end;
end;

(****************************************************************************)

procedure GoPreviousRec (var pos, len:integer);   {display previous record}

var
  tmpRec: TAddressRec;

begin
  if len=0 then                     {if file is empty}
    writeln ('Folder is empty.')    {do not display any record}
  else
    begin
      pos:=pos-1;
      if pos=0 then       {if current record is the first record in the file}
        pos := 1;         {program does not show previous record}
      writeln;
      writeln ('Record: ',pos);
      tmpRec := AddressBook[pos];
      with tmpRec do
        DisplayRec(pos, len); {display previous record}
    end;
end;

{***********************************************************************}

procedure GoFirstRec (var pos, len: integer); {display first record}

var
  tmpRec: TAddressRec;

begin
  pos:=1;
  if len=0 then                 {if file is empty}
    writeln('Folder is empty.') {do not display any record}
  else
    begin
      writeln;
      writeln ('Record: ',pos);
      tmpRec := AddressBook[pos];
      with tmpRec do
        DisplayRec(pos, len);    {display first record}
    end;
end;

{****************************************************************************}

procedure GoLastRec (var pos, len: integer); {display last record}

var
  tmpRec: TAddressRec;

begin
  pos:=len;
  if pos=0 then                {if file is empty}
    writeln('Folder is empty.') {do not display any record}
  else
    begin
      writeln;
      writeln ('Record: ',pos);
      tmpRec := AddressBook[pos];
      with tmpRec do
        DisplayRec(pos, len);      {display previous record}
    end;
end;

{****************************************************************************}

procedure CloseRec (len: integer);   {close the record and write to file}

var
  i:integer;

begin
  rewrite (dataFile);
  for i:=1 to len do
    begin
      write (dataFile, AddressBook[i]);     {write data to file}
    end;
  close (dataFile);                         {close file}
  writeln ('Folder is closed.');
end;

{****************************************************************************}

begin  {main program}

  Error:= false;  {starts out as false}
  tmpPos:= 0;

  repeat
    ShowMainMenu(choice);  {show main menu}
    case choice of
      '1':   {open an existing file}
        begin
          writeln;
          writeln('Please input the filename:'); {user enters filename}
          readln(filename);
          if not OpenFile(filename,len) then  {if file does not exist}
          writeln('File not found.')
          else
            begin           {file is opened}
              pos:=1;
              quitSub:= false;  {starts out as false}
              repeat
                ShowOptionsMenu(choice, len); {show options menu}
                case choice of
                  '1': DisplayRec(pos, len);  {display a record}
                  '2': AddNewRec(len);        {add a new record}
                  '3': DeleteRec(pos);        {delete a record}
                  '4': begin
                         SearchFile(choice, len);  {search for a record}
                         case choice of
                           '1': begin     {search by first name}
                                  if SearchFirstName(tmpPos) then {if record is found}
                                    pos:= tmpPos;
                                end;
                           '2': begin    {search by last name}
                                  if SearchLastName(tmpPos) then  {if record is found}
                                    pos:=tmpPos;
                                end;
                         else
                           InvalidChoice(choice, error); {if user enters incorrect option}
                         end;
                       end;
                  '5': GoNextRec(pos, len);  {display next record}
                  '6': GoPreviousRec(pos, len);  {display previous record}
                  '7': GoFirstRec(pos, len);    {display first record}
                  '8': GoLastRec(pos, len);     {display last record}
                  '9': begin
                         CloseRec(len);        {close record and save data}
                         quitsub:= true;
                       end;
                         else
                           InvalidChoice(choice, error); {if user enters incorrect option}
                         end;
              until quitSub;    {will exit options menu when quitsub becomes true}
          end; {if open file}
        end;  {main menu choice 1}

      '2':    {create a new file}
        begin
          if not createfile(filename) then
            writeln ('Invalid Filename. Folder not created.');
        end; {main menu choice 2}

      '3':   {delete an existing file}
        begin
          writeln ('Enter filename.');  {user enters filename}
          readln (filename);
          writeln ('Delete folder? Y/N');   {asks permission to delete file}
          readln (response);
          if (response='y') or (response='Y') then  {if response is yes}
            DeleteFile(filename)               {file is deleted}
          else
            begin
              if (response='n') or (response='N') then {if response is no}
                writeln ('Folder not deleted.')  {file is not deleted}
              else
                InvalidChoice (choice, error); {if user enters incorrect choice}
            end;
        end;   {main menu choice 3}

      '4':   {quit program}
        begin
          Quit(Exit);   {exit program}
          error:=true;
        end;  {main menu choice 4}

    else
      InvalidChoice(choice, error)  {if user enters incorrect choice}
    end;
    until Error;  {will exit menu menu when error becomes true}
end.  {main program}